{Include file for SPLAY}
Const
    TracksPerDisc = 30;
    ShortStr_Size = 50;
    LongStr_Size = 70;

    SongsFName = 'SONGS.SNG';
    DiscsFName = 'DISCS.SNG';

Type
   (* User interface basic type - time representor: *)
  TMSF = record {<T>rack, <M>inutes, <S>econds, <F>rames}
    (* Order was reversed (FSMT) to match the Red book format: *)
    Frm,        {frame, 1/75 of a second}
    Sec, Min,   {seconds, minutes}
    Trk : Byte; {track, or 0 to represent disc time, or 0/1 as audio/data}
  end;

  (* the TrkArr is actually used only as a pointer in DiscRec record.
     the MSF part - location of track on disc.
     the T (Trk field) is 1 for data track track, 0 for audio.        *)
  TrkArr = array[01..TracksPerDisc] of TMSF;

  (* Use this type to represent a whole disc, and compare between discs: *)
  DiscRec = record
    Length : TMSF;   {disc's length in [MSF], number of tracks in Trk field}

    {First change - ^TrkArr changed to TrkArr}
    Track : {^}TrkArr; {TMSF(s), track length [MSF]/data-flags [T]}
  end;

  SongNames = Array[1..TracksPerDisc] of String[ShortStr_Size];

  IdxRec = Record
        Name, Band : String[ShortStr_Size]; {Disc + Band Name}
        drec : DiscRec;
        Songs: SongNames; {Name of Songs}
   End;

  { Note that the maximum number of Discs in DISCS.SNG
    is : (MaxLongInt div SizeOf(IdxRec)) -1 = 1,450,021 but no check
    has been made to verify that
    1. The program will actually work with file of that size;
    2. The program will actually not work with file above that size;
    3. I'm sane
  }

  IdxRecFile = File of IdxRec;

