Unit SONGS; {SONGS FILES HANDLER}
{*******************************}INTERFACE{**********************************}
{$I+,B-,R+,S+,Q+}

Uses CDAUDIO, CRT;
Const
    TDiscs: Word = 0;
    TSongs: Word = 0;

    Discs_Sig = 'Discs File';
    {Temporary Files - will be OVERWRITTEN !}
    TempFName  = '$$TEMP$$.SNG';

    ESC = #27;
    ENTER = #13;
    MaxLines        = 100;
    MaxWordsPerLine = 20;

    HebChar = [''..''];  {#128 .. #154}
    EngChar = ['A'..'Z','a'..'z'];
    ControlChar = [#0..#31];

    Yes   = 'Y';
    No    = 'N';
    YesNo = [Yes,No];

    SongHead_Color = Yellow;
    SongBody_Color = White;
    WordPlay_Color = LightBlue;
    BG_Color = Black;
    FG_Color = Lightgray;
    FGDis_Color = DarkGray;
    CDSupp_Color = Red;
    Choose_Color = LightGray;
    Menu_Color = LightGray;
    Buttom_Color = LightBlue;
    Info_Color = LightMagenta;
    Buf_Color  = LightCyan;

    Lf= #10;
    Cr= #13;
    EOL = Cr+Lf;

    {SB Const}
    DefBaseIO = $220;
    {SB Const}

    MaxBufSize = 64*1024 - 8 ; { Maximum size is 64K-8 bytes }

Type
   StrScreen= String[80];

   { The size/type of the variables that will hold Pause lengths }
   PauseVar = LongInt;

   WordRec = Record
         Len: Byte;
         P : PauseVar;
         Words: String[20];
   End;

   Loc = Record
     X,Y: Byte;
   End;

   SongRec = Record
        Name, Band, Perform, Album: String[LongStr_Size];  {Name of Song / Band / Performer / Album}
        Words : Array[1..MaxLines] of String[LongStr_Size];    {Array of song-lyrics}
        Pause : Array[1..MaxLines,1..MaxWordsPerLine] of PauseVar; {Pause Lengths}
        Start: LongInt;     { Start time }
        Year, Lines: Word;    {Year / Lines }
        {Max  - total lines in song LYRICS (Including BLANK Lines) }

        Ready,Hebrew : Boolean;

        {Song has Hebrew Lyrics ?
         All other info like disc+song names
         must be in Hebrew too; Not really actually - but I think they'll
         be written straightened to right }

        {Ready determines whether or not the song has rhythm info.
         It's either full or nothing. middle-things will just not work.
        }

   End;

   SongID = Record
      BandN, SongN : String[LongStr_Size];{Song/Band Name}
      Location     : LongInt;   {file position }
      Idx, Length  : Word;      {Index in songs file, Length of Song}
   End;


   Function SearchSongName(Var InFile: Text; Var LS: SongID;
                           BandName,SongName:String): Boolean;
   {Searches BandName and SongName in InFile : }
   {If found, location in InFile is moved into Location}
   {Returns wheather song if found}

   Function SearchSongList(Var InFile: Text; BandName: String; List: SongNames; Var Track: Byte;
            Var Idx: Integer; Max: Byte): Word;
   {Counts all songs of BandName from List }
   {Track = The track of last song found }
   {Idx   = SongsFile IDX of last song found }
   {Max   = Total songs in List }

   Function SearchSongIdx(Var InFile: Text; Var LS: SongID;
                          Idx: Word) : Boolean;
   {Validates record IDX of InFile is valid}

   Function LoadSong(Var InFile: Text; Var Song:SongRec; LS: SongID;
            LoadOne: Boolean; Var Max: Word): Boolean;
   {Loads Song from LS.Location to Song variable from InFile}
   {If LoadOne=True then only validates the whole file and returns
    result else actually load ...}

   Procedure SaveSong(Var Song: SongRec; LS: SongID);
   {Saves Song from Song variable to OutFile at LS.Location}

   Procedure DelSong(Var InFile: Text);
   {Deletes Song at location from InFile}

   Function ValSong(Var InFile: Text; Var Max: Word): Boolean;
   {Validates InFile is a Song File, prompting and exiting on errors}
   {Returns whether error occoured}

   Procedure Abort(Mes: String);

   Function Strip(Str:string):string;
   {Strips Blanks at start and end of Str}

   Function SizeFile(FileName:string): LongInt;
   {Returns Size in bytes of FileName}

   Procedure FlushKeyBuffer;
   {Flushes Keyboard Buffer (Head=Tail ; Doesn't Flush #0+#xx}

   Function  KeyPressed : Boolean;
   {Indicates whether a key is available at the keyboard buffer,
    does not wait for one, does not remove it from the buffer}

   Function  DelayMS(MS: LongInt; VAR Pressed: Char; Playing: Boolean; Var KeyP: Boolean): LongInt;
   {Delays MS milliseconds, Terminates on 'X' or 'P'}
   {returns key pressed in PRESSED, pauses play if Playing=True}


   Function DelayMSS(Var Pressed: Char; Playing: Boolean; Var KeyP: Boolean): LongInt;
   {For Editing - Counts time until keypressed}
   {Returns special key at PRESSED, pauses play if Playing=True}


   Function  DelayS(MS: LongInt; X, Y: Byte; VAR Pressed: Char; Playing: Boolean; Var KeyP: Boolean): LongInt;
   {Terminates on 'X' or 'P'; Shows time passed in [X,Y] }

   Function  DelaySS(X,Y: Byte; Var Pressed: Char; Playing: Boolean; Var KeyP: Boolean): LongInt;
   {For Editing - Terminates on 'P' + 'X' and shows time passed}

   Function Hebrew(Mes: String): String;
   {Get an Hebrew/English string}

   Function Exist(FileName : String) : Boolean;
   {Does FileName exists ? (True/False)}

   Procedure CursorOff;
   {Turn Cursor Off}

   Procedure CursorOn;
   {Turn Cursor On}

   Procedure ImportDiscs(Var DiscsFile: IdxRecFile);


   Procedure ImportSongs;


   Procedure DelDisc(Var DiscsFile: IdxRecFile);


   Procedure DiscsList(Var DiscsFile: IdxRecFile);


   Procedure SongsList(Var InFile: Text; Var LS: SongId; AskInfo: Boolean);


   Function NeatTime(Time: Byte): String;


   Procedure ChangeSong(Var InFile: Text; Var LS: SongID; Var Song: SongRec; TSongs: Word);


   Function TextFilePos(Var f : Text) : LongInt;


   Function TextFileSize(Var f : Text) : LongInt;


   Procedure TextSeek(Var f : Text; n : LongInt);

   Function Up(S: String): String;
   {Returns Upcase equivalent of S}

   Function TimeStr: String;

   Function DateStr: String;

   Function AskLang: Byte;

   Function SearchSong(Var InFile: Text; Var Song: SongRec; Var LS: SongID): Boolean;

   Procedure Pause;

   Function ResetDSP: Word;

   Procedure InstallKBDHandler(NewInt9: Pointer);

   Procedure RestoreKBDHandler;

   Function GetDSPVer: Real;

   Procedure DetectSBPort;

   Function ValIDX(Var DiscsFile: IdxRecFile): Boolean;

Var OldInt9: Pointer;
    BaseIO: Word;
    ResetSB,ReadSB,ReadBuf,WriteBuf: Word;

{******************************}IMPLEMENTATION{******************************}
Uses HTIMERS, DOS, Keyboard;

Const
     MaxTries = 100; {Maximum lines to search for the next element }
     {Exist to prevent 10MB files from being searched to the buttom}

Type
   bitNum = 0..7;
   bit    = 0..1;

Var
  Line : String;
  Timer: HTimerObj;

Procedure InstallKBDHandler(NewInt9: Pointer);
Begin
   GetIntVec($09,OldInt9);
   SetIntVec($09,NewInt9);
End;

Procedure RestoreKBDHandler;
Begin
   SetIntVec($09,OldInt9);
End;
{ ------------------------------------------------------------------------- }
Procedure Wait(MS: LongInt);
Var Time: LongInt;
Begin
   Timer.SetZero;
   Repeat Time := Timer.GetMSecs;
   Until Time>=MS;
End;

{ ------------------------------------------------------------------------- }
Procedure Pause;
Begin
   FlushKeyBuffer;
   While Not KeyPressed do;
   FlushKeyBuffer;
End;

{ ------------------------------------------------------------------------- }
Function GetBit(b : Byte; n : bitNum) : bit;
begin
  GetBit := bit(odd(b shr n));
end;

{ ------------------------------------------------------------------------- }
Function IsBusy: Boolean;
Var Test: Word;
    Time: LongInt;

Begin
    Timer.SetZero;
    Repeat
         Test:=Port[WriteBuf];
         Time := Timer.GetMSecs;
    Until (GetBit(Test,7)=0) or (Time>=100);

    If GetBit(Test,7)=0 then IsBusy:=False
    Else IsBusy:=True;

End;
{ ------------------------------------------------------------------------- }
Function IsData: Boolean;
Var Test  : Word;
    Time  : longint;

Begin
   Timer.SetZero;
   Repeat
       Test:=Port[ReadBuf];
       Time := Timer.GetMSecs;
   Until (GetBit(Test,7)=1) or (Time>=100);

   If GetBit(Test,7)=1 then IsData:=True
                       else IsData:=False;
End;

{ ------------------------------------------------------------------------- }
Function ResetDSP: Word;
Begin
   Port[ResetSB]:=1;
   Wait(3); {Delays 3 MSecs}
   Port[ResetSB]:=0;

   If IsData then
      ResetDSP:=Port[ReadSB]
   else
      ResetDSP:=0;
End;

{ ------------------------------------------------------------------------- }
Function GetDSPVer: Real;
Var Major, Minor: Byte;

Begin
    Major:=0;
    Minor:=0;
    If Not IsBusy then
       Begin
           Port[WriteBuf]:=$E1;  {Send DSP version request to the SB Card}
           If IsData then
              Begin
                  Major:=Port[ReadSB];  {Take Major Ver}
                  If IsData then Minor:=Port[ReadSB];  {Take Minor Ver}
              End;
       End;
    GetDSPVer:=Major + ( Minor * 0.01 );
End;
{ ------------------------------------------------------------------------- }
Procedure DetectSBPort;
Var S: String;
    Port, Err: Word;
Begin
   {Get 'Blaster' variable }
   S := Up(GetEnv('Blaster'));
   If S='' then Exit;

   Delete(S,1,POS('A',S));
   Delete(S,POS(' ',S),Length(S));
   Insert('$',S,1);

   Val(S,Port,Err);
   If Err<>0 then BaseIO:=Port
             else BaseIO:=DefBaseIO;

   ResetSB := BaseIO+$06;
   ReadSB  := BaseIO+$0A;
   ReadBuf := BaseIO+$0E;
   WriteBuf:= BaseIO+$0C;
End;

{ ------------------------------------------------------------------------- }
Procedure GetFileMode; Assembler;
Asm
  CLC
  CMP    ES:[DI].TextRec.Mode, fmInput
  JE     @1
  MOV    [InOutRes], 104         { 'File not opened For reading' }
  xor    AX, AX                  { Zero out Function result }
  xor    DX, DX
  STC
@1:
end;  { GetFileMode }

{ ------------------------------------------------------------------------- }
Function TextFilePos(Var f : Text) : LongInt; Assembler;
Asm
  LES    DI, f
  CALL   GetFileMode
  JC     @1
  xor    CX, CX                  { Get position of File Pointer }
  xor    DX, DX
  MOV    BX, ES:[DI].TextRec.handle
  MOV    AX, 4201h
  inT    21h                     { offset := offset-Bufend+BufPos }
  xor    BX, BX
  SUB    AX, ES:[DI].TextRec.Bufend
  SBB    DX, BX
  ADD    AX, ES:[DI].TextRec.BufPos
  ADC    DX, BX
@1:
end;  { TextFilePos }

{ ------------------------------------------------------------------------- }

Function TextFileSize(Var f : Text) : LongInt; Assembler;
Asm
  LES    DI, f
  CALL   GetFileMode
  JC     @1
  xor    CX, CX                  { Get position of File Pointer }
  xor    DX, DX
  MOV    BX, ES:[DI].TextRec.handle
  MOV    AX, 4201h
  inT    21h
  PUSH   DX                      { Save current offset on the stack }
  PUSH   AX
  xor    DX, DX                  { Move File Pointer to Eof }
  MOV    AX, 4202h
  inT    21h
  POP    SI
  POP    CX
  PUSH   DX                      { Save Eof position }
  PUSH   AX
  MOV    DX, SI                  { Restore old offset }
  MOV    AX, 4200h
  inT    21h
  POP    AX                      { Return result}
  POP    DX
@1:
end;  { TextFileSize }

{ ------------------------------------------------------------------------- }

Procedure TextSeek(Var f : Text; n : LongInt); Assembler;

Asm
  LES    DI, f
  CALL   GetFileMode
  JC     @2
  MOV    CX, Word Ptr n+2        { Move File Pointer }
  MOV    DX, Word Ptr n
  MOV    BX, ES:[DI].TextRec.Handle
  MOV    AX, 4200h
  inT    21h
  JNC    @1                      { Carry flag = reading past Eof }
  MOV    [InOutRes], AX
  JMP    @2
  { Force read next time }
@1:
  MOV    AX, ES:[DI].TextRec.Bufend
  MOV    ES:[DI].TextRec.BufPos, AX
@2:
end;  { TextSeek }

{ ------------------------------------------------------------------------- }

Procedure FlushKeyBuffer;
Begin
    MemW[$0000:$041C] := MemW[$0000:$041A];
End;     { flush keyboard buffer }

{ ------------------------------------------------------------------------- }

Function KeyPressed : Boolean; Assembler;
Asm
     Mov  Ah, 01h
     Int  16h

     MOV  AX,False      { Assume 0 (doesn't effect FLAGS) }
     JZ   @1            { If False - Jump End }

     MOV  AX,True       { Assign 1 }
@1 :
End;

{---------------------------------------------------------}

Procedure CursorOff; Assembler;
Asm
  MOV   ax,$0100
  MOV   cx,$2607
  INT   $10
end;

Procedure CursorOn; Assembler;
Asm
  MOV   ax,$0100
  MOV   cx,$0506
  INT   $10
end;

{ ------------------------------------------------------------------------- }
Function Strip(Str:string):string;
{Strips the #32 (spaces) and #0 chars
 in the beginning & ending of a string variable }
Var L, i: Byte;
begin
   L := Length(Str);

   If L=0 then
      Begin
         Strip := '';
         Exit;
      End;

   i := 1;
   While (L > 0) and ( Str[i] in [' ',#0] ) do
         Begin
            Inc(i);
            Dec(L);
         End;
   Delete(Str,1,i-1);

   While (L > 0) and ( Str[L] IN [' ',#0] ) do
         Begin
            Dec(L);
            Delete(Str,Length(Str),1);
         End;

   Strip := Str;
end;  {Function Strip}

{ ------------------------------------------------------------------------- }
Function Hebrew(Mes: String): String;
Const
   {Hebrew keyboard mapping }
   SourceConv: String ='"''-TCDSVUZJYHFLKNOBIXGP;M.ERA,1234567890 |\/*+[]{}()!@#$%^&*_=`~?QW:<>';
   DestConv:  String  = '",-1234567890 |\.*+[]{}()!@#$%^&*_=;~?/`:<>';

   AltDec: Array[False..True] of String[7]=('','English');

Var
  Count: Integer;
  HebStr: StrScreen;
  SaveX, X, SaveY: Byte;
  Enter,Alt: Boolean;
  Ch,Decr: Char;
Begin
   { init }
   Enter:=False;
   Alt  :=False;
   Decr:=#0;
   Ch  :=#0;
   { init }

   SaveY:=WhereY;
   X:=78-Length(Mes);
   GotoXY(1,SaveY);
   Write(' ':X,Mes);
   GotoXY(1,25);
   If Alt then Write(AltDec[Alt],' ':72)
          else Write(' ':74,AltDec[Alt]);
   GotoXY(X,SaveY);
   HebStr:='';
   Enter:=False;
   Repeat
       While Not KeyPressed do
                 If AltPress then
                    Begin
                      Alt:=Not Alt;
                      SaveX:=WhereX;
                      GotoXY(1,25);
                      If Alt then Write(AltDec[Alt],' ':72)
                             else Write(' ':74,AltDec[Alt]);
                      GotoXY(SaveX,SaveY);
                      While AltPress do;
                    End;
       Ch:=ReadKey;
       For Count:=1 to Length(SourceConv) do
           If SourceConv[Count]=UpCase(Ch) then
              Begin
                 Decr:=DestConv[Count];
                 Break;
              End;

       If (Alt) and (Decr>#0) then Decr:=Ch;

       Case Ch of
            #27:     {Esc = Do Nothing}
               Begin
               End;
            #0:     {Function key}
              ReadKey;
            #8:     {Backspace}
              If WhereX<X then
                 Begin
                    GotoXY(WhereX+1,SaveY);
                    Write(' ');
                    GotoXY(WhereX-1,SaveY);
                    Delete(HebStr,Length(HebStr),1);
                 End;

            #13:   {Enter}
               Enter:=True;
         else
            Begin
               If (WhereX>1) and (Decr>#0) then
                  Begin
                     HebStr:=HebStr+Decr;
                     Write(Decr);
                     GotoXY(WhereX-2,SaveY);
                  End
            End;
       End; {case}
   Until Enter;  { Enter }

   GotoXY(1,SaveY+1);
   For X:=1 to (length(HebStr) div 2) do
       Begin
          Ch:=HebStr[X];
          HebStr[X] := HebStr[Length(HebStr)+1-X];
          HebStr[Length(HebStr)+1-X]:=Ch;
       End;
   Hebrew:=HebStr;
End;    {Procedure Hebrew}

{ ------------------------------------------------------------------------- }
Function DelayMS;
{Delays MS MilliSeconds or until 'P','X','+','-' pressed}
Var Time: LongInt;
    Key: Char;
Begin
    Time:=0;
    MS:=MS*1000;
    KeyP:=False;
    Timer.Setzero;

    Repeat
         Time:=Timer.GetMUSecs; {MicroSeconds Resolution}
         If Keypressed then
            Begin
                Key:=UpCase(ReadKey);
                If Key in ['P','X','+','-'] then
                   Begin
                       If Playing then PauseAudio;
                       KeyP:=True;
                       Pressed:=Key;
                   End
                else If Key=#0 then Key:=ReadKey;

            End;
    Until (MS-Time<=0) or (KeyP); {Until time passed or keypressed}

    DelayMS := (MS-Time) div 1000;
end;

{ ------------------------------------------------------------------------- }
Function DelayMSS;
{For Editing - Doesn't show time left}
{Terminates normally when any key is pressed (Not including 'P' or 'X')}
Var Time: LongInt;
    Key: Char;
    Quit: Boolean;
Begin
   Time:=0;
   Quit:=False;
   KeyP:=False;

   Timer.Setzero;
   Repeat
       Time:=Timer.GetMUSecs; {MicroSeconds Resolution}
       If Keypressed then
          Begin
             Key:=UpCase(ReadKey);

             If Key in ['P','X','-','+'] then
                Begin
                   If Playing then PauseAudio;
                   KeyP:=True;
                   Pressed:=Key;
                End
             else If Key=#0 then Key:=ReadKey;

             Quit:=True;
          End;
    Until (Time>=2000000000) or (Quit);

    If Time>0 then
       DelayMSS:=Time div 1000 {Assuming human error ~0MS !}
end;

{ -------------------------------------------------------------------------- }

Function DelayS;
{Terminates on 'X' or 'P' and shows time left}
Var Time: LongInt;
    Key: Char;
Begin
    Time:=0;
    MS:=MS*1000;
    KeyP:=False;
    Timer.Setzero;

    Repeat
         If Frac(Time/10) = 0 then
            Begin
                GotoXY(X, Y);
                Write( (MS-TIME)/1000000:2:1,' ');
            End;

         Time:=Timer.GetMUSecs;
         If KeyPressed then
            Begin
               Key:=UpCase(ReadKey);
               If Key in ['P','X','+','-'] then
                  Begin
                     If Playing then PauseAudio;
                     KeyP:=True;
                     Pressed:=Key;
                  End
               else if Key=#0 then Key:=ReadKey;
            End;

    Until (MS-Time<=0) or (KeyP);

    DelayS := (MS-TIME) div 1000;
end;

{----------------------------------------------------------------------------}

Function DelaySS;
{For Editing - Terminates on 'P' + 'X' and shows time past}
{Terminates normally when any key is pressed (Not including 'P')}
Var
  Key: Char;
  Quit{Quit Procedure}: Boolean;
  Time,Old : LongInt;

Begin
    Time:=0;
    Old:=0;
    Quit:=False;
    TextColor(Magenta);
    KeyP:=False;

    Timer.Setzero;
    Repeat
         If Frac(Time/10) = 0 then
            Begin
                GotoXY(X, Y);
                Write( (OLD+TIME)/1000000:2:1,' ');
            End;

         Time:=Timer.GetMUSecs;

         If Keypressed then
            Begin
                Key:=UpCase(ReadKey);
                If Key='P' then
                   Begin
                      If Playing then PauseAudio;

                      Inc(Old,Time);           {Store Time}
                      Time:=0;                 {Reset Counter}
                      GotoXY(X,Y);
                      Write( (Old)/1000000:2:1,' (PAUSED)');
                      GotoXY(1,25);
                      Write('Press <X> to exit, or any other key to continue');

                      Key:=UpCase(ReadKey); {Waits for a key}

                      If Key='X' then
                         Begin
                            Pressed:=Key;
                            Quit:=True;
                            KeyP:=True;
                         End
                      else If Key=#0 then Key:=ReadKey;

                      GotoXY(X,Y);
                      Write( (Old/1000000):2:1,'         ');
                      GotoXY(1,25);
                      Write('<P>ause                                        ');
                      Timer.SetZero;       {Re-initiate Timer}
                      If Playing then ResumeAudio;
                   End
                else
                  Begin
                     If Key=#0 then Key:=ReadKey
                        else If Key in ['-','+'] then
                                Begin
                                   Pressed:=Key;
                                   KeyP:=True;
                                End;
                     Quit:=True;
                  End;
            End;
    Until (Time>=2000000000){ (MaxLongInt-Reserve) } or Quit;

    DelaySS:=(OLD+TIME) div 1000;  {Assuming Human Error ~0MS !}
end;

{ -------------------------------------------------------------------------- }

Procedure Abort(Mes: String);
Begin
    Writeln(Mes);
    Halt(0);
End;

Function Exist(FileName : String) : Boolean;
begin
    Exist := (FSearch(FileName, '') <> '')
end;      (* FileExist.                                           *)

{ ------------------------------------------------------------------------- }
Function SizeFile(Filename:string): LongInt;
{Returns Size of file (Check for existence FIRST)}
var Inf: SearchRec;
begin
    FindFirst(Filename,AnyFile,Inf);
    If DosError=0 then
                     SizeFile := Inf.Size
                  else
                     SizeFile := -1;
end;

{ ------------------------------------------------------------------------- }
Function SearchSongList;
Var Band, Found: Boolean;
    Count, i, T : Word;
Begin
   Band :=False;
   Found:=False;

   Reset(InFile);
   Idx:=0;
   Count:=0;
   T:=0;
   While Not EOF(InFile) do
         Begin
            Readln(InFile,Line);
            Line := UP(Strip(Line));
            If Line<>'' then
               Case Line[1] of
                    ':':
                       Band := (Line=':'+UP(BandName));

                     '@': If (Line<>'@ALBUMS') and (Line<>'@INFO') then
                       Begin
                          Inc(Count);
                          i:=1;
                          If Band then
                              Begin
                                 Repeat
                                     Found := (Line='@'+UP(List[i]) );
                                     Inc(i);
                                 Until (i>Max) or (Found);
                                 If Found then
                                    Begin
                                       Inc(T);
                                       Track:=i-1;
                                       Idx := Count;
                                    End;

                              End;
                           End;
                        End; {Case}
                End;


    Close(InFile);
    SearchSongList := T;
End;
{----------------------------------------------------------------------------}
Function SearchSongName;
Var Band, Found: Boolean;
    Count : Word;
    T: LongInt;
    TBandN, TSongN: String;
Begin
    Band :=False;
    Found:=False;
    Count:=0;

    If (UP(LS.BandN)=UP(BandName)) and (UP(LS.SongN)=UP(SongName)) then
       SearchSongName:=True {Return True}
    Else
       Begin
           Reset(InFile);
           While (Not EOF(InFile)) and (Not Found) do
                 Begin
                     Readln(InFile,Line);
                     Line := Strip(Line);
                     If Line<>'' then
                        Case Line[1] of
                          ':':
                             Begin
                                Band := (UP(Line)=':'+UP(BandName));
                                If Band then TBandN:=Copy(Line,2,Length(Line)-1);
                             End;

                          '@': If (UP(Line)<>'@ALBUMS') and (UP(Line)<>'@INFO') then
                                Begin
                                    Inc(Count);
                                    If Band and ( UP(Line)='@'+UP(SongName)) then
                                       Begin
                                          Found:=True;
                                          TSongN:=Copy(Line,2,Length(Line)-1);
                                       End;
                                End;
                        End; {Case}
                 End;
           If Found then {Cache it !}
                       Begin
                           With LS do
                                Begin
                                   BandN:=TBandN;
                                   SongN:=TSongN;
                                   Location:=TextFilePos(InFile);
                                   Idx:=Count;
                                End;

                           {Current line is '@' thus we must proceed to next}
                           {song to find the length}

                           Repeat
                               {note the ineffeciency but
                                finding next song and calculating
                                textfilepos(infile)-ls.location-length(line)
                                is not good because there are special char's
                                in the way (CR/LF)
                               }

                               T := TextFilePos(InFile);
                               Readln(InFile,Line);
                               Line := Strip(Line);
                           Until Eof(InFile) or ((Line<>'') and (Line[1] in [':','@']));

                           {TextFilePos - LS.Location MUST BE 0<X<65535}
                           { (only because of LS.Length: Word)         }
                           LS.Length:=T-LS.Location;
                           SearchSongName:=True;
                       End
                    Else
                       SearchSongName:=False;{Return False}
           Close(InFile);
       End;
End;
{ ------------------------------------------------------------------------- }
Function SearchSongIdx;
{Verifies that record number IDX is valid}
Var Band, Found: Boolean;
    CurBand, CurSong, TStr : String;
    Count: Word;
    T: Longint;
Begin
    Count:=0;
    Band :=False;
    Found:=False;
    CurBand:='';
    CurSong:='';

    If LS.Idx=Idx then                   {Already in Cache ?}
                     SearchSongIdx:=True {Return True}
    Else
       Begin
           Reset(InFile);
           While (Not EOF(InFile)) and (Not Found) do
                 Begin
                     Readln(InFile,Line);
                     Line := Strip(Line);
                     If Length(Line)>0 then
                     Case Line[1] of
                          ':':
                             CurBand:=Strip( Copy(Line,2,Length(Line) ) );

                          '@': If (Line<>'@ALBUMS') and (Line<>'@INFO') then
                             Begin
                                CurSong:=Strip( Copy(Line,2,Length(Line) ) );
                                Inc(Count);
                             End;
                     End; {Case}
                     Found:= (Count=Idx);
                 End;
           If Found then {Cache it !}
                       Begin
                           LS.BandN   :=CurBand;
                           LS.SongN   :=CurSong;
                           LS.Idx     :=Idx;
                           LS.Location:=TextFilePos(InFile);

                           Repeat
                                T:=TextFilePos(InFile);
                                Readln(InFile,Line);
                                Line := Strip(Line);
                           Until Eof(InFile) or ((Line<>'') and (Line[1] in [':','@']));

                           {TextFilePos - LS.Location MUST BE 0<X<65535}
                           LS.Length:=T-LS.Location;

                           SearchSongIdx:=True;
                       End
                    Else
                       SearchSongIdx:=False;{Return False}
           Close(InFile);
       End;
End;

{ ------------------------------------------------------------------------- }

Procedure SaveSong;
Const
 Blank = #32;

Var
 NumRead, NumWritten, BufSeg, OrgOfs, BufOfs: Word;

{Add a string to the buffer }
Procedure AddStr(S: String);
Begin
   Move(S[1], Ptr(BufSeg,BufOfs)^, Length(S));
   Inc(BufOfs, Length(S));
End;

Function NumOfWords(S: String): Word;
Var i,T: Word;
Begin
   T := 0;
   While S[1]=' ' do Delete(S,1,1);
   While S[Length(S)]=' ' do Delete(S,Length(S),1);
   For i:=1 to Length(S) do
       If S[i]=' ' then Inc(T);

   NumOfWords := T+1;
End;

Function HebComp(S: String): String;
{Hebrew Complementary : Add blanks !}
Var TempS: String;
    Len: Integer;
Begin
   If (Song.Hebrew) and (S<>'') then
      Begin
         Len := 78-Length(S);
         FillChar(TempS,Len+1,Blank); {Fill in blanks }
         TempS[0]:=Chr(Len);          {Set correct length }
      End
   else
      TempS:='';

   HebComp:=TempS;
End;

Var SongsFile, TempFile: File;
    i,j, WordCount: Integer;
    C, St: String;
    BufPtr: Pointer;
    BufSize: LongInt;

Begin
   { Allocate memory for the buffer }
   BufSize := MaxAvail;
   If BufSize>MaxBufSize then BufSize:=MaxBufSize;
   GetMem(BufPtr,BufSize);

   BufSeg := LongInt(BufPtr) Shr 16;
   BufOfs := (LongInt(BufPtr) Shl 16) Shr 16;
   OrgOfs := BufOfs;

   Assign(TempFile,TempFName);
   Rewrite(TempFile,1);
   Assign(SongsFile,SongsFName);
   Reset(SongsFile,1);

   { Seek to cut location }
   With LS Do Seek(SongsFile,Location+Length);

   { Copy rest of file to a temporary place }
   Repeat
      BlockRead(SongsFile,BufPtr^,BufSize,NumRead);
      BlockWrite(TempFile,BufPtr^,NumRead,NumWritten);
   Until (NumRead<BufSize) or (NumRead<>NumWritten);
   Close(TempFile);

   With LS Do Seek(SongsFile,Location);
   Truncate(SongsFile);

   { Fill in the buffer with the new parsed song}

With Song do
Begin
   If Perform='' then Perform:='Unknown performer';
   St := HebComp(Perform)+Perform+EOL+EOL;
   AddStr(St);

   Str(Start,St);
   St := '$'+St;
   St := HebComp(St)+St+EOL+EOL;
   AddStr(St);

   Str(Year,St);
   If Album='' then Album:='Unknown Album';
   St := St+','+Album;
   St := HebComp(St)+St+EOL+EOL;
   AddStr(St);

   For i:=1 to Lines do
       Begin
          AddStr(HebComp(Words[i])+Words[i]+EOL);
          If Words[i]<>'' then
             Begin
                WordCount := NumOfWords(Words[i]);
                St := '';
                For j:=1 to WordCount do
                    Begin
                       Str(Pause[i,j],C);
                       St := St + C;
                       If j<>WordCount then St := St+Blank;
                    End;
                St := HebComp(St) + St + EOL;
                AddStr(St);
             End;
       End; { For }
End; { With }

   AddStr(EOL);

   {Append file}
   i := BufOfs-OrgOfs ;
   BlockWrite(SongsFile,BufPtr^,i, NumWritten);

{  In case u wanna look in to the buffer ... }
{   ClrScr;
   i:=OrgOfs;
   While i<BufOfs do
   Begin
      C := Char(Ptr(BufSeg,i)^);
      Write(C);

      Inc(i,Length(C));
      Delay(10);
   End;
   Readln;}

   Reset(TempFile,1);
   { Concat end of the file }
   Repeat
      BlockRead(TempFile,BufPtr^,BufSize,NumRead);
      BlockWrite(SongsFile,BufPtr^,NumRead,NumWritten);
   Until (NumRead<Bufsize) or (NumRead<>NumWritten);

   Close(TempFile);
   Close(SongsFile);
   Erase(TempFile);

   FreeMem(BufPtr,BufSize);
End;

{ ------------------------------------------------------------------------- }
Function ValSong;
Var SongL: SongRec;
    LS: SongID;
Begin
   ValSong :=LoadSong(InFile,SongL,LS,False,Max);
End;

{ ------------------------------------------------------------------------- }
Function LoadSong;
Var PauseCount: Word;

Var Count, Count2, Code, W: Integer;
    CheckPause: Boolean;
    LongCount: LongInt;
    Stri, TempStr: String;

Procedure WriteInfo;
Begin
    With Song do
     Begin
        Writeln('Song IDX : ',Count2);
        Writeln('Band Name: ',Band);
        Writeln('Song Name: ',Name);
        Writeln('Performer: ',Perform);
        Writeln('Album    : ',Year,',',Album);
     End;
    FlushKeyBuffer;
    While Not KeyPressed do;
    FlushKeyBuffer;
End;

{ Checks for EOF; If TRUE, closes InFile and prints a message }
Function IsEOF: Boolean;
Begin
    If EOF(InFile) then
       Begin
          Writeln('Unexpected end of file !');
          WriteInfo;
          IsEOF:=True;
          LoadSong:=False;
        End
          Else
             IsEOF:=False;
End;

{ Prints a message, closes InFile }
Procedure Arrange(Mes: String);
Begin
    LoadSong:=False;
    Writeln;
    Writeln;
    Writeln(Mes);
    WriteInfo;
End;

Function NextItem(M: String): Boolean;
Var Quit: Boolean;
Begin
  Count:=0;
  Quit:=False;
  Repeat
      If Count=MaxTries then
         Begin
            Arrange(M);
            Quit:=True;
         End;

      If Quit then Break; {Break out of the loop}

      Inc(Count);
      Readln(InFile,Line);
      Line := Strip(Line);

      Quit:=IsEOF;
  Until (Line<>'') or (Quit);

  NextItem:=Not Quit;
End;

{Sorry I just had to use labels here }
Label 1,2,99;

Begin
   {Song counter }
   Count2:=0;

   LoadSong:=True;
   Reset(InFile);
   If EOF(InFile) then Goto 99;
   Line:='';             { Keep here }

   If LoadOne then
      Begin
         TextSeek(InFile,LS.Location);  {Seek to requested location}

         FilLChar(Song,SizeOf(Song),0);
         Song.Name:=LS.SongN;
         Song.Band:=LS.BandN;
         Song.Perform:='';
         {search for next non-empty line}
         If not NextItem('Cannot find performer(s) name !') then
            Goto 99;

         Goto 1;
      End;

{ Repeat until
  1. EOF has reached (we processed all songs )
  2. an error occured (something else expected )
}

Repeat {Song Start}
    Count:=0;

    CheckPause := (Line='@ALBUMS') or (Line='@INFO');
    {Search for a new band or a new song marker }
    While (Line='') or not (Line[1] in [':','@']) or CheckPause do
          Begin
             If Count=MaxTries then
                Begin
                   Arrange('Cannot find band/song name !');
                   Goto 99;
                End;
             Inc(Count);
             Readln(InFile,Line);
             Line := Strip(Line);
             If EOF(InFile) then Goto 99;
             CheckPause := (Line='@ALBUMS') or (Line='@INFO');
          End;

    {*Note the condition (Line<>'') is required
      because otherwise the expression Line[1] is undefined
      and therfore can have any value
      only String[0] is always defined and always holds
      the length of the string.
    }

    Count:=0;
    { If reached a new band marker }
    If Line[1]=':' then
       Begin
          {save band name }
          Song.Band:=Copy(Line,2,Length(Line));

          {and search for a new song marker }
          Repeat
              If Count=MaxTries then
                 Begin
                    Arrange('Cannot find song name !');
                    Goto 99;
                 End;
              Inc(Count);
              Readln(InFile,Line);
              Line := Strip(Line);
              If EOF(InFile) then Goto 99;

              CheckPause := (Line<>'@ALBUMS') and (Line<>'@INFO');
              {'@ALBUMS' and '@INFO' are special symbols used to represent
              something other than a new song. We try to skip it }

          {until reached a new song marker }
          Until (Line<>'') and (Line[1]='@') and (CheckPause);
       End;

    {Song Counter }
    Inc(Count2);

    {Save song name }
    Song.Name:=Copy(Line,2,Length(Line));

    Song.Perform:= '';

    {search for next non-empty line}
    If not NextItem('Cannot find performer(s) name !') then
       Goto 99;

1: {Load Next Song Label}

    {Line = Performer}
   If Line[1]='!' then
      Begin
         Song.Ready:=False;
         If not NextItem('Cannot find song lyrics !') then
            Goto 99;

         Goto 2;
      End;

    If not (Line[1] in ['$','0'..'9']) then
       Begin
          With Song do
          If Perform='' then Perform:=Line
                        else Perform:=Perform+', '+Line;

          If not NextItem('Cannot find performer name / start time / album info !') then
             Goto 99;

          If not (Line[1] in ['$','0'..'9']) then Goto 1;
       End;

    With Song do
         If Line[1]='$' then
            Begin
               Line:=Strip(Line);
               TempStr:=Copy(Line,2,Length(Line));
               Val(TempStr,LongCount {Start},Code);
               If (Code=0) and (LongCount>=0) and (LongCount<=MaxLongInt) then
                  Start := LongCount
               else
                  Begin
                     Arrange('Error in Song Starting time !');
                     Goto 99;
                  End;

               Ready:=True;
               If not NextItem('Cannot find album/song words info !') then
                  Goto 99;
            End
         Else
            Ready:=False;


    If Line[1] in ['0'..'9'] then
       Begin
          Stri:=Copy(Line,1,Pos(',',Line)-1);
          If Stri='' then Stri:=Line;
          Val(Stri, LongCount {Song.Year}, Code);

          If (Code=0) and (LongCount>=0) and (LongCount<=MaxLongInt) then
             Song.Year := LongCount
          else
             Begin
{                Writeln('Error in album year, trying to continue');}
{                Arrange('Error in album year !');
                Goto 99;}
             End;

          If Stri=Line then
             Song.Album:=''
          else
             Song.Album:=Copy(Line,Pos(',',Line)+1,Length(Line));

          If not NextItem('Cannot find song words !') then
             Goto 99;
       End;

2: { Skip to song-word's loading label}
    PauseCount:=1;
    W:=0;
    CheckPause:=False;
    {Strip leading and ending blanks }
    Line:=Strip(Line);
    {Strip double blanks }
    While Pos('  ',Line)>0 do
          Delete(Line, Pos('  ',Line), 1);

    Count:=0;
    {determine whether it is Hebrew or English song }
    With Song Do
         Begin
            Repeat
               Inc(Count);
            Until Line[Count] in (HebChar+EngChar);

            If (Line[Count] in HebChar) then
               Hebrew:=True
            else
               Hebrew:=False;
         End;
    Count:=0;

    While Not (EOF(InFile)) and Not ((Line<>'') and (Line[1] in ['@',':','^'])) do
     {: = New Band}
     {@ = New Song}
     {^ = Song Info and Other(!!!)}
          Begin
             If CheckPause then
                Begin
                   W:=0;
                   CheckPause:=False;
                   While (Line<>'') and (Song.Ready) do
                         Begin
                            Inc(PauseCount);
                            Inc(W);

                            If Pos(' ',Line)=0 then Line:=Line+' ';
                            TempStr:=Copy(Line,1,Pos(' ',Line)-1);

                            Val(TempStr,LongCount {Song.Pause[Count,W]},Code);
                            If (Code=0) and (LongCount>=0) and (LongCount<=MaxLongInt)
                               and (W<=MaxWordsPerLine) then
                                   Song.Pause[Count,W] := LongCount
                                else
                                   Begin
                                      If W>MaxWordsPerLine then
                                        Arrange('Line length exceeds max.')
                                      else
                                        Arrange('Bad pause length.');

                                      Goto 99;
                                   End;


                            Line:=Strip(Line);
                            Delete(Line,1,Length(TempStr)+1);
                         End;
                End
              else
                 If (Line='') or not (Line[1] in ControlChar) then
                        Begin
                           Inc(Count);
{                           If Line[1]='^' then Readln(InFile,Line)
                                          else }
                           If Count<=MaxLines then
                              Song.Words[Count]:=Line
                           else
                              Begin
                                 Arrange('Too many lines.');
                                 Goto 99;
                              End;

                           If (Song.Ready) and (Line<>'')
                              then CheckPause:=True;
                        End
                     else
                        If Count=0 then Count:=1;
             If Count>0 then
                Begin
                   Readln(InFile,Line);
                   {Strip leading and ending blanks }
                   Line:=Strip(Line);
                   {Strip double blanks }
                   While Pos('  ',Line)>0 do
                         Delete(Line, Pos('  ',Line), 1);
                End;


          End;

    If EOF(InFile) then
       Begin
          Inc(Count);
          Song.Words[Count]:=Line;
       End;
    Song.Lines:=Count;
Until (EOF(InFile)) or (LoadOne);


99: {End Processing Label }
    Close(InFile);

    Max := Count2;
    If LoadOne then With Song do
       If Lines>0 then
          While Words[Lines]='' do
                Dec(Lines);

End;

{----------------------------------------------------------------------------}
Function ValIDX(Var DiscsFile: IdxRecFile): Boolean;
Var Temp: IdxRec;
Begin
   Reset(DiscsFile);
   Read(DiscsFile,Temp);
   TDiscs:=FileSize(DiscsFile)-1;
   Close(DiscsFile);
   If TDiscs>0 then
                  Write(TDiscs)
               else
                  Write('No');
   Write(' Disc Records...');
   ValIdx:=(Temp.Name=Discs_Sig);
End;

{----------------------------------------------------------------------------}
Function GetFileName(S: String): String;
Var Quit: Boolean;
    Count: Byte;

Begin
   Writeln('Please specify a file to import to the');
   Writeln(S);
   Writeln('After this you can play out songs from it.');
   Writeln;
   Quit:=False;
   Count:=WhereY+1;
   Repeat
       GotoXY(1,Count);
       Writeln;
       GotoXY(1,Count-1);
       Write('File Name (<Enter> to quit) :');
       CursorOn;
       Readln(Line);                      {Get File Name}
       If Line='' then Quit:=True
          else
             Begin
                If Not Exist(Line) then
                   Write('File does not exist !',#7)
                else
                   If SizeFile(Line)=0 then
                      Write('Cannot accept empty file !',#7)
                    else Quit:=True;
             End;
    Until Quit;

   GetFileName := Line;
End;
{----------------------------------------------------------------------------}
Procedure ImportDiscs;
Type
     CRCPtr = ^CRCListType;

     CRCListType = Record
        CRC: Word;
        Link: CRCPtr;
     End;

{This routine was taken from SWAG
No special efforts were made to verify the resolution of
this CRC16 relative to the size of our data element (=SizeOf(IdxRec)=1.5kb )

Anyway it is only used to compare discs elements of type IdxRec
instead of verifying the whole structure.
I hope it gives a reasonable speed improvement
}

Function Crc16(Var Data; wo_Size : Word) : Word; Assembler;
Asm
  push   ds
  xor    dx, dx
  lds    si, Data
  mov    bx, wo_Size
@L1:
  xor    ah, ah
  lodsb
  mov    cx, 8
  shl    ax, cl
  xor    dx, ax
  mov    cx, 8
@L2:
  shl    dx, 1
  jnc    @L3
  xor    dx, $1021
@L3:
  loop   @L2
  dec    bx
  jnz    @L1
  pop    ds
  mov    ax, dx
end; { Crc16. }

Function Search(Index: CRCPtr; Item: Word): Boolean;
{ Assumes : CRCPtr items number > 0 }
Var Found: Boolean;
Begin
   Repeat Found := (Index^.CRC = Item);
          Index := Index^.Link;
   Until (Found) or (Not Assigned(Index));

   Search := Found;
End;

Var ImportFile: IdxRecFile;
    Head, CrcList: CrcPtr;
    i: Integer;
    DRec: IdxRec;
    CRC: Word;
    FSize, Mem: LongInt;
Begin
   ClrScr;

   Reset(DiscsFile);
   FSize := FileSize(DiscsFile);
   Close(DiscsFile);

   If FSize < 2 then
      Begin
         Writeln('File is empty or got no disc records.');
         Pause;
         Exit;
      End
   else
      Begin
         Mem := (FSize-1)*SizeOf(DRec);
         If MemAvail < Mem then
         Begin
            Writeln('Not enough memory: ',Mem,' bytes should be free.');
            Abort('Please free more memory.');
            Halt(1);
         End;
      End;

   Line := GetFileName('Discs File ("'+DiscsFName+'").');
   If Line='' then Exit;

   Assign(ImportFile, Line);

   Writeln;
   Write('Validating Discs File Header... ');

   If ValIdx(ImportFile) then
      Writeln('OK.')
   else
      Begin
         Writeln('Failed !');
         Exit;
      End;

   Writeln;

   {Create a linked-list of DiscsFile record's CRC }
   Reset(DiscsFile);
   Seek(DiscsFile, 1); {Move to 2nd file component - Skip header}

   New(CRCList);
   Head := CRCList;    {Save head address }
   CrcList^.Link := Nil;

   {Allocate memory and calc. CRC values }
   For i:=1 to FSize-1 do
       Begin
          Read(DiscsFile, DRec);
          CrcList^.CRC := CRC16(DRec, SizeOf(DRec));
          New(CrcList^.Link);
          CrcList := CrcList^.Link;
       End;
   CrcList^.Link := Nil;
   Close(DiscsFile);

   {Copy non-existent record from ImportFile to DiscsFile }
   Reset(ImportFile);
   Seek(ImportFile, 1); {Move to 2nd file component - Skip header}
   For i:=1 to FileSize(ImportFile)-1 do
       Begin
          Read(ImportFile, DRec);
          CRC := CRC16(Drec, SizeOf(DRec));
          If Not Search(Head, CRC) then
             Begin
                Write('Importing');
                Write(DiscsFile, Drec);
             End
          else
             Write('Already Exists');

          Writeln(' "',Drec.Name,'"');
       End;
   Close(ImportFile);

   {Dispose allocated memory }
   CRCList := Head;
   For i:=1 to FSize do
       Begin
          Head := CRCList^.Link;
          Dispose(CRCList);
          CRCList := Head;
       End;

   Writeln;
   Writeln('Press any key to return to menu.');
   Pause;
End;

{----------------------------------------------------------------------------}
Procedure ImportSongs;
Var InFName: String;
    InFile: Text;
    File1, File2: File;
    NumRead,NumWritten: Word;
    BufSize: LongInt;
    B: Array[1..2] of Char;
    BufPtr: Pointer;

Begin
   ClrScr;

   InFName := GetFileName('Songs File ("'+SongsFName+'").');
   If InFName='' then Exit;

   Assign(InFile, InFNAME);

   Write('Verifying Input-File  :"',InFNAME,'"... ');
   If Not ValSong(InFile,NumRead) then Exit;
   Writeln('OK');

   Assign(File1,InFName);
   Assign(File2,SongsFName);

   Reset(File1,1);
   Reset(File2,1);
   Seek(File2,FileSize(File2));

   { Allocate memory for the buffer }
   BufSize := MaxAvail;
   If BufSize>MaxBufSize then BufSize:=MaxBufSize;
   GetMem(BufPtr,BufSize);

   Repeat
       BlockRead(File1,BufPtr^,BufSize,NumRead);
       BlockWrite(File2,BufPtr^,NumRead,NumWritten);
   Until (NumRead<BufSize) or (NumRead<>NumWritten);

   FreeMem(BufPtr,BufSize);

   Close(File1);

   {Write EOL }
   B := EOL;
   BlockWrite(File2,B,SizeOf(B));

   Close(File2);

   FlushKeyBuffer;
   While Not Keypressed do;
   FlushKeyBuffer;
End;

Procedure DelDisc;
Var Count: Byte;
    Key: Char;
    TempFile: IdxRecFile;
    Idx: IdxRec;
Begin
    ClrScr;
    Reset(DiscsFile);
    Read(DiscsFile,Idx); {Read header record }

    While Not EOF(DiscsFile) do
          Begin
              If (FilePos(DiscsFile)+1 mod 23)=0 then
                 Begin
                    Write('More ? ( <Esc>=No ; <Any other key>=Yes) ');
                    Key := ReadKey;
                    If Key=#0 then FlushKeyBuffer
                       else If Key=ESC then Break;
                 End;
              Read(DiscsFile,Idx);
              With Idx do
                   Write(FilePos(DiscsFile)-1,'.',' ',Name,' ':(50-Length(Name)));
              With Idx.Drec.Length do
                   Writeln('Total [',Min,':',NeatTime(Sec),Sec,'],Tracks:',Trk);

          End;
    FlushKeyBuffer;
    CursorOn;
    GotoXY(1,23);
    Write('Which entry do you want to DELETE (1..',FileSize(DiscsFile)-1,') ?');
    Readln(Count);
    If (Count<1) or (Count>FileSize(DiscsFile)-1) then Exit;
    Writeln;
    Write('Are you sure you want to delete disc #',Count,' (Y/N) ?');
    Inc(Count);
    Repeat
        Key:=UpCase(ReadKey);
        If Key=#0 then ReadKey; {Empty buffer if function key}
        FlushKeyBuffer;
    Until Key in YesNo;

    Writeln;
    If Key=No then Exit; {Current Procedure}

    {Record Deleting Start}
    Assign(TempFile, TempFName);
    ReWrite(TempFile);
    Reset(DiscsFile);
    While not EOF(DiscsFile) do
          Begin
              Read(DiscsFile,Idx);
              If FilePos(DiscsFile)<>Count then Write(TempFile,Idx);
          End;
    Close(DiscsFile);
    Close(TempFile);
    Erase(DiscsFile);
    Rename(TempFile, DiscsFName);
    Assign(DiscsFile, DiscsFName);
    {Record Deleting End}

    Write('Entry ', Count-1, ' Successfully deleted.');
    FlushKeyBuffer;
    While Not Keypressed do;
    FlushKeyBuffer;
End;

Procedure ShowSongs(Var InFile: Text);

Var CurBand: String;
    Count, Last, Cur: Integer;
    Key: Char;

Begin
   Count:=0;
   Cur:=1;
   Last:=-1;
   ClrScr;
   Reset(InFile);
   While Not EOF(InFile) do
         Begin
           Line:=#255;
           Readln(InFile,Line);
           Line := Strip(Line);
           If Line[1]=':' then CurBand:=Copy(Line,2,Length(Line))
              else
                 If Line[1]='@' then
                                   Begin
                                      If not (Line='@ALBUMS') and not (Line='@INFO') then
                                             {No support for remarks}
                                         Begin
                                            Inc(Count);
                                            Writeln(Count,'. ',CurBand,' / ',Copy(Line,2,Length(Line)));
                                            Last:=Cur;
                                         End;
                                   End;
           Inc(Cur);
           If ((Count mod 24)=0) and (Cur-1=Last) then
              Begin
                 Write('More ? ( <Esc>=No ; <Any other key>=Yes) ');
                 CursorOn;
                 Key := ReadKey;
                 CursorOff;
                 Writeln;
                 If Key=#0 then FlushKeyBuffer
                    else If Key=ESC then Break;
              End;
         End;
    Close(InFile);
End;

Procedure DelSong;
Var Count: Integer;
Begin
    ClrScr;
    ShowSongs(InFile);
    For Count:=1 to 10 do
        Begin
        End;
End;

Procedure DiscsList;
Var Key: Char;
    Count: Integer;
    Y: Byte;
    Valid: Boolean;
    Idx: IdxRec;
Begin
    ClrScr;
    Reset(DiscsFile);
    Read(DiscsFile, Idx);
    While Not EOF(DiscsFile) do
          Begin
             If FilePos(DiscsFile)+1 mod 23 = 0 then
                Begin
                   Write('More ? ( <Esc>=No ; <Any other key>=Yes) ');
                   CursorOn;
                   Key := ReadKey;
                   CursorOff;
                   If Key=#0 then FlushKeyBuffer
                      else If Key=ESC then Break;
                End;
             Read(DiscsFile,Idx);
             With Idx do
                  Write(FilePos(DiscsFile)-1,'.',' ',Name,' ':(50-Length(Name)));
             With Idx.Drec.Length do
                  Writeln('Total [',Min,':',NeatTime(Sec),Sec,'],Tracks:',Trk);

          End;
    Close(DiscsFile);
    FlushKeyBuffer;
    CursorOn;
    Writeln;
    Write('Do you want more details about specific record (Y/N) ? ');
    Repeat
         Key:=UpCase(ReadKey);
    Until Key in YesNo;
    FlushKeyBuffer;
    Writeln;
    If Key=Yes then
       Begin
           Reset(DiscsFile);
           Repeat
                Valid:=False;
                Write('Enter record number (1..',FileSize(DiscsFile)-1,'): ');
                Y:=WhereY;
                Readln(Count);
                GotoXY(1,Y);
                Valid:=(Count>0) and (Count<=FileSize(DiscsFile)-1 );
           Until Valid;

           ClrScr;
           Seek(DiscsFile,Count);
           Read(DiscsFile, Idx);
           With Idx do
                Begin
                    Writeln('Name: ',Idx.Name);
                    With Drec.Length do
                         Begin
                             Writeln('Time: ',Min,':',NeatTime(Sec),Sec,'.',Frm);
                             Writeln('Total Tracks: ',Trk);
                         End;

                    For Count:=1 to Drec.Length.Trk do
                        With Drec.Track[Count] do
                             Writeln('#',Count,': ',Songs[Count]:50,' [',Min,':',NeatTime(Sec),Sec,']');
                End;
           Close(DiscsFile);
           GotoXY(1,25);
           Write('Press any key to return to menu...');
           FlushKeyBuffer;
           While Not KeyPressed do;
           FlushKeyBuffer;
       End;
End;

Procedure SongsList;

Var Rec: Integer;
    Key: Char;
    Val: Boolean;
    InRec: SongRec;
    T: Word;

Begin
   ShowSongs(InFile);
   CursorOn;
   Writeln;
   If Not AskInfo then Exit;
   Write('Do you want more details about a record (Y/N) ?');
   FlushKeyBuffer;
   Repeat
       Key:=UpCase(ReadKey);
       FlushKeyBuffer;
   Until Key in YesNo;
   If Key=No then Exit;
   GotoXY(1,WhereY);
   DelLine;
   Write('More info on record number (1..',TSongs,', 0=Cancel): ');
   FlushKeyBuffer;
   Repeat
       Readln(Rec);
       FlushKeyBuffer;
   Until Rec in [0..TSongs];
   If Rec=0 then Exit; {Exit current procedure}

   Val:=SearchSongIdx(InFile,LS,Rec);
   If Not Val then
                 Begin
                    Write('Invalid Song!');
                    Readln;
                 End;

   If Val then LoadSong(InFile,InRec,LS,True,T)
          else Exit;
   ClrScr;
   With InRec do
        Begin
           Writeln('Band Name : ',Band);
           Writeln('Song Name : ',Name);
           Writeln('Performer : ',Perform);
           Writeln('Album     : ',Album);
           Writeln('Year      : ',Year);
           Writeln('Start Time: ',Start);
           Writeln('Lines     : ',Lines);
           Writeln('Ready     : ',Ready);
           Writeln('Hebrew    : ',Hebrew);
           Writeln('-----------------------');

           Readln;
        End;
End;

Procedure ChangeSong;
Var Rec: Integer;
    T: Word;
Begin
   Write('Load record number (1..',TSongs,', 0 quits): ');
   FlushKeyBuffer;
   Repeat
       Readln(Rec);
       FlushKeyBuffer;
   Until Rec in [0..TSongs];
   If Rec=0 then Exit;

   If SearchSongIdx(InFile,LS,Rec) then
      LoadSong(InFile,Song,LS,True,T);
End;


Function NeatTime;
Begin
    If Time<10 then NeatTime:='0'
    Else NeatTime:='';
End;

Function Up;
Var I: Integer;
Begin
    For I := 1 to Length(S) do
        If S[I] in ['a'..'z'] then
           Dec(S[I], 32);

    Up := S;
End;

Function TimeStr;
Var H, M, S, S100: Word;
    HStr, MStr, SStr: String;
Begin
   GetTime(H, M, S, S100);
   Str(H,HStr);
   Str(M,MStr);
   Str(S,SStr);
   TimeStr := HStr + ':' + MStr + ':' + SStr;
End;

Function DateStr;
Var Y, M, D, DOW: Word;
    YStr, MStr, DStr: String;
Begin
   GetDate(Y,M,D,DOW);
   Str(Y,YStr);
   Str(M,MStr);
   Str(D,DStr);
   {Format is DD/MM/YYYY (my favorite)}
   DateStr := DStr + '/' + MStr + '/' + YStr;
End;

Function AskLang: Byte;
Var Key: Char;
Begin
   CursorOn;
   Write('Do you want to use <H>ebrew or <E>nglish namings (<ESC>=QUIT) ?');
   FlushKeybuffer;
   Repeat
       Key:=UpCase(Readkey);
       FlushKeyBuffer;
   Until Key in ['E','H',#27];
   CursorOff;

   ClrScr;
   Case Key of
        'H':
           Begin
              AskLang := 1;
              GotoXY(44,4);
              Write('<ALT>      ');
           End;
        'E': AskLang := 2;
      else
         Begin
            AskLang := 0;
            Exit;
         End;
   End;

End;

Function SearchSong;
Var Heb: Byte;
    Key: Char;
    T: Word;
    Found: Boolean;
    BN, SN: String;
    TempLS: SongID;
Begin
   ClrScr;
   Heb := AskLang;
   If Heb=0 then Exit;
   GotoXY(1,2);

   CursorOn;
   If Heb=1 then
      Begin
         BN:=Hebrew(' : ');
         GotoXY(1,4);
         SN:=Hebrew(' :  ');
      End
   else   {Key='E'}
      Begin
         Write('Band Name: ');
         Readln(BN);
         GotoXY(1,4);
         Write('Song Name: ');
         Readln(SN);
      End;

   Writeln;
   Found := SearchSongName(InFile, TempLS, BN, SN);
   If Found then
      Begin
         Writeln('Found at entry ', TempLS.IDX,'.');
         Write('Load it ? (Y/N)');
         Repeat
            Key := UpCase(ReadKey);
            If Key=#0 then FlushKeyBuffer;
         Until Key in YesNo;
         If Key=Yes then
            Begin
               LS := TempLS;
               LoadSong(InFile,Song,LS,True,T);
               SearchSong:=True;
            End;
      End
   else
      Begin
         Writeln('Not Found.');
         SearchSong:=False;
         Readln;
      End;

   CursorOff;
End;

End. {Unit SONGS}
